From c1dc92b61d2b31d8b00a75a03b62f47874366f7e Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Sun, 24 Jul 2022 00:38:55 +0100
Subject: [PATCH 12/21] Remove pyspotify: removed all remaining pyspotify
 usage.

---
 MANIFEST.in                       |   1 -
 mopidy_spotify/backend.py         |   1 -
 mopidy_spotify/browse.py          |   1 -
 mopidy_spotify/search.py          |   1 -
 mopidy_spotify/translator.py      | 120 +--------------
 setup.cfg                         |   1 -
 tests/conftest.py                 | 238 ------------------------------
 tests/test_browse.py              |   2 -
 tests/test_lookup.py              |   2 -
 tests/test_playlists.py           |   1 -
 tests/test_translator.py          | 236 -----------------------------
 12 files changed, 1 insertion(+), 603 deletions(-)

diff --git a/MANIFEST.in b/MANIFEST.in
index 57401cdb..9d9fd9b3 100644
--- a/MANIFEST.in
+++ b/MANIFEST.in
@@ -9,7 +9,6 @@ include tox.ini
 recursive-include .github *
 
 include mopidy_*/ext.conf
-include mopidy_spotify/spotify_appkey.key
 
 recursive-include tests *.py
 recursive-include tests/data *
diff --git a/mopidy_spotify/backend.py b/mopidy_spotify/backend.py
index 59a6a467..f1deb961 100644
--- a/mopidy_spotify/backend.py
+++ b/mopidy_spotify/backend.py
@@ -5,7 +5,6 @@
 import pykka
 from mopidy import backend, httpclient
 
-import spotify
 from mopidy_spotify import Extension, library, playlists, web
 
 logger = logging.getLogger(__name__)
diff --git a/mopidy_spotify/browse.py b/mopidy_spotify/browse.py
index 425c92e9..2e8ab8f3 100644
--- a/mopidy_spotify/browse.py
+++ b/mopidy_spotify/browse.py
@@ -2,7 +2,6 @@
 
 from mopidy import models
 
-import spotify
 from mopidy_spotify import countries, playlists, translator
 from mopidy_spotify.web import WebLink
 from mopidy_spotify.utils import flatten
diff --git a/mopidy_spotify/search.py b/mopidy_spotify/search.py
index 74413a17..e3d87510 100644
--- a/mopidy_spotify/search.py
+++ b/mopidy_spotify/search.py
@@ -3,7 +3,6 @@
 
 from mopidy import models
 
-import spotify
 from mopidy_spotify import lookup, translator
 
 _SEARCH_TYPES = ["album", "artist", "track"]
diff --git a/mopidy_spotify/translator.py b/mopidy_spotify/translator.py
index fb9b640c..e7db3f2f 100644
--- a/mopidy_spotify/translator.py
+++ b/mopidy_spotify/translator.py
@@ -3,8 +3,6 @@
 
 from mopidy import models
 
-import spotify
-
 logger = logging.getLogger(__name__)
 
 
@@ -26,29 +24,7 @@ def __call__(self, *args, **kwargs):
             return value
 
 
-@memoized
-def to_artist(sp_artist):
-    if not sp_artist.is_loaded:
-        return
-
-    return models.Artist(uri=sp_artist.link.uri, name=sp_artist.name)
-
-
-@memoized
-def to_artist_ref(sp_artist):
-    if not sp_artist.is_loaded:
-        return
-
-    return models.Ref.artist(uri=sp_artist.link.uri, name=sp_artist.name)
-
-
-def to_artist_refs(sp_artists, timeout=None):
-    for sp_artist in sp_artists:
-        sp_artist.load(timeout)
-        ref = to_artist_ref(sp_artist)
-        if ref is not None:
-            yield ref
-
+#TODO: memoize web functions?
 
 def web_to_artist_ref(web_artist):
     if not valid_web_data(web_artist, "artist"):
@@ -65,47 +41,6 @@ def web_to_artist_refs(web_artists):
             yield ref
 
 
-@memoized
-def to_album(sp_album):
-    if not sp_album.is_loaded:
-        return
-
-    if sp_album.artist is not None and sp_album.artist.is_loaded:
-        artists = [to_artist(sp_album.artist)]
-    else:
-        artists = []
-
-    if sp_album.year is not None and sp_album.year != 0:
-        date = f"{sp_album.year}"
-    else:
-        date = None
-
-    return models.Album(
-        uri=sp_album.link.uri, name=sp_album.name, artists=artists, date=date
-    )
-
-
-@memoized
-def to_album_ref(sp_album):
-    if not sp_album.is_loaded:
-        return
-
-    if sp_album.artist is None or not sp_album.artist.is_loaded:
-        name = sp_album.name
-    else:
-        name = f"{sp_album.artist.name} - {sp_album.name}"
-
-    return models.Ref.album(uri=sp_album.link.uri, name=name)
-
-
-def to_album_refs(sp_albums, timeout=None):
-    for sp_album in sp_albums:
-        sp_album.load(timeout)
-        ref = to_album_ref(sp_album)
-        if ref is not None:
-            yield ref
-
-
 def web_to_album_ref(web_album):
     if not valid_web_data(web_album, "album"):
         return
@@ -131,51 +66,6 @@ def web_to_album_refs(web_albums):
             yield ref
 
 
-@memoized
-def to_track(sp_track, bitrate=None):
-    if not sp_track.is_loaded:
-        return
-
-    if sp_track.error != spotify.ErrorType.OK:
-        logger.debug(f"Error loading {sp_track.link.uri!r}: {sp_track.error!r}")
-        return
-
-    if sp_track.availability != spotify.TrackAvailability.AVAILABLE:
-        return
-
-    artists = [to_artist(sp_artist) for sp_artist in sp_track.artists]
-    artists = [a for a in artists if a]
-
-    album = to_album(sp_track.album)
-
-    return models.Track(
-        uri=sp_track.link.uri,
-        name=sp_track.name,
-        artists=artists,
-        album=album,
-        date=album.date,
-        length=sp_track.duration,
-        disc_no=sp_track.disc,
-        track_no=sp_track.index,
-        bitrate=bitrate,
-    )
-
-
-@memoized
-def to_track_ref(sp_track):
-    if not sp_track.is_loaded:
-        return
-
-    if sp_track.error != spotify.ErrorType.OK:
-        logger.debug(f"Error loading {sp_track.link.uri!r}: {sp_track.error!r}")
-        return
-
-    if sp_track.availability != spotify.TrackAvailability.AVAILABLE:
-        return
-
-    return models.Ref.track(uri=sp_track.link.uri, name=sp_track.name)
-
-
 def valid_web_data(data, object_type):
     return (
         isinstance(data, dict)
@@ -184,14 +74,6 @@ def valid_web_data(data, object_type):
     )
 
 
-def to_track_refs(sp_tracks, timeout=None):
-    for sp_track in sp_tracks:
-        sp_track.load(timeout)
-        ref = to_track_ref(sp_track)
-        if ref is not None:
-            yield ref
-
-
 def web_to_track_ref(web_track, *, check_playable=True):
     if not valid_web_data(web_track, "track"):
         return
diff --git a/setup.cfg b/setup.cfg
index 4d45fe57..a57b2bb5 100644
--- a/setup.cfg
+++ b/setup.cfg
@@ -29,7 +29,6 @@ python_requires = >= 3.7
 install_requires =
     Mopidy >= 3.0.0
     Pykka >= 2.0.1
-    pyspotify >= 2.0.5
     requests >= 2.20.0
     setuptools
 
diff --git a/tests/conftest.py b/tests/conftest.py
index d34ac1db..f536b564 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -4,7 +4,6 @@
 from mopidy import backend as backend_api
 from mopidy import models
 
-import spotify
 from mopidy_spotify import backend, library, utils, playlists, web
 
 
@@ -49,243 +48,6 @@ def web_mock():
     patcher.stop()
 
 
-@pytest.fixture
-def spotify_mock(web_mock):
-    patcher = mock.patch.object(backend, "spotify", spec=spotify)
-    yield patcher.start()
-    patcher.stop()
-
-
-@pytest.fixture
-def sp_user_mock():
-    sp_user = mock.Mock(spec=spotify.User)
-    sp_user.is_loaded = True
-    sp_user.canonical_name = "alice"
-    return sp_user
-
-
-@pytest.fixture
-def sp_artist_mock():
-    sp_artist = mock.Mock(spec=spotify.Artist)
-    sp_artist.is_loaded = True
-    sp_artist.name = "ABBA"
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:artist:abba"
-    sp_link.type = spotify.LinkType.ARTIST
-    sp_link.as_artist.return_value = sp_artist
-    sp_artist.link = sp_link
-
-    return sp_artist
-
-
-@pytest.fixture
-def sp_unloaded_artist_mock():
-    sp_artist = mock.Mock(spec=spotify.Artist)
-    sp_artist.is_loaded = False
-    sp_artist.name = None
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:artist:abba"
-    sp_link.type = spotify.LinkType.ARTIST
-    sp_link.as_artist.return_value = sp_artist
-    sp_artist.link = sp_link
-
-    return sp_artist
-
-
-@pytest.fixture
-def sp_artist_browser_mock(sp_artist_mock, sp_album_mock):
-    sp_artist_browser = mock.Mock(spec=spotify.ArtistBrowser)
-    sp_artist_browser.artist = sp_artist_mock
-    sp_artist_browser.albums = [sp_album_mock, sp_album_mock]
-
-    sp_artist_mock.browse.return_value = sp_artist_browser
-
-    return sp_artist_browser
-
-
-@pytest.fixture
-def sp_album_mock(sp_artist_mock):
-    sp_album = mock.Mock(spec=spotify.Album)
-    sp_album.is_loaded = True
-    sp_album.name = "DEF 456"
-    sp_album.artist = sp_artist_mock
-    sp_album.year = 2001
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:album:def"
-    sp_link.type = spotify.LinkType.ALBUM
-    sp_link.as_album.return_value = sp_album
-    sp_album.link = sp_link
-
-    return sp_album
-
-
-@pytest.fixture
-def sp_unloaded_album_mock(sp_unloaded_artist_mock):
-    sp_album = mock.Mock(spec=spotify.Album)
-    sp_album.is_loaded = True
-    sp_album.is_loaded = False
-    sp_album.name = None
-    # Optimally, we should test with both None and sp_unloaded_artist_mock
-    sp_album.artist = sp_unloaded_artist_mock
-    sp_album.year = None
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:album:def"
-    sp_link.type = spotify.LinkType.ALBUM
-    sp_link.as_album.return_value = sp_album
-    sp_album.link = sp_link
-
-    return sp_album
-
-
-@pytest.fixture
-def sp_album_browser_mock(sp_album_mock, sp_track_mock):
-    sp_album_browser = mock.Mock(spec=spotify.AlbumBrowser)
-    sp_album_browser.album = sp_album_mock
-    sp_album_browser.tracks = [sp_track_mock, sp_track_mock]
-    sp_album_browser.load.return_value = sp_album_browser
-
-    sp_album_mock.browse.return_value = sp_album_browser
-
-    return sp_album_browser
-
-
-def sp_track_mock(sp_artist_mock, sp_album_mock):
-    sp_track = mock.Mock(spec=spotify.Track)
-    sp_track.is_loaded = True
-    sp_track.error = spotify.ErrorType.OK
-    sp_track.availability = spotify.TrackAvailability.AVAILABLE
-    sp_track.name = "ABC 123"
-    sp_track.artists = [sp_artist_mock]
-    sp_track.album = sp_album_mock
-    sp_track.duration = 174300
-    sp_track.disc = 1
-    sp_track.index = 7
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:track:abc"
-    sp_link.type = spotify.LinkType.TRACK
-    sp_link.as_track.return_value = sp_track
-    sp_track.link = sp_link
-
-    return sp_track
-
-
-@pytest.fixture(name="sp_track_mock")
-def sp_track_mock_fixture(sp_artist_mock, sp_album_mock):
-    return sp_track_mock(sp_artist_mock, sp_album_mock)
-
-
-@pytest.fixture
-def sp_unloaded_track_mock(sp_unloaded_artist_mock, sp_unloaded_album_mock):
-    sp_track = mock.Mock(spec=spotify.Track)
-    sp_track.is_loaded = False
-    sp_track.error = spotify.ErrorType.OK
-    sp_track.availability = None
-    sp_track.name = None
-    # Optimally, we should test with both None and [sp_unloaded_artist_mock]
-    sp_track.artists = [sp_unloaded_artist_mock]
-    # Optimally, we should test with both None and sp_unloaded_album_mock
-    sp_track.album = sp_unloaded_album_mock
-    sp_track.duration = None
-    sp_track.disc = None
-    sp_track.index = None
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:track:abc"
-    sp_link.type = spotify.LinkType.TRACK
-    sp_link.as_track.return_value = sp_track
-    sp_track.link = sp_link
-
-    return sp_track
-
-
-@pytest.fixture
-def sp_starred_mock(sp_user_mock, sp_artist_mock, sp_album_mock):
-    sp_track1 = sp_track_mock(sp_artist_mock, sp_album_mock)
-    sp_track1.link.uri = "spotify:track:oldest"
-    sp_track1.name = "Oldest"
-
-    sp_track2 = sp_track_mock(sp_artist_mock, sp_album_mock)
-    sp_track2.link.uri = "spotify:track:newest"
-    sp_track2.name = "Newest"
-
-    sp_starred = mock.Mock(spec=spotify.Playlist)
-    sp_starred.is_loaded = True
-    sp_starred.owner = sp_user_mock
-    sp_starred.name = None
-    sp_starred.tracks = [sp_track1, sp_track2]
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:user:alice:starred"
-    sp_link.type = spotify.LinkType.STARRED
-    sp_link.as_playlist.return_value = sp_starred
-    sp_starred.link = sp_link
-
-    return sp_starred
-
-
-@pytest.fixture
-def sp_playlist_mock(sp_user_mock, sp_track_mock):
-    sp_playlist = mock.Mock(spec=spotify.Playlist)
-    sp_playlist.is_loaded = True
-    sp_playlist.owner = sp_user_mock
-    sp_playlist.name = "Foo"
-    sp_playlist.tracks = [sp_track_mock]
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:user:alice:playlist:foo"
-    sp_link.type = spotify.LinkType.PLAYLIST
-    sp_link.as_playlist.return_value = sp_playlist
-    sp_playlist.link = sp_link
-
-    return sp_playlist
-
-
-@pytest.fixture
-def sp_unloaded_playlist_mock(sp_unloaded_track_mock):
-    sp_playlist = mock.Mock(spec=spotify.Playlist)
-    sp_playlist.is_loaded = False
-    sp_playlist.owner = None
-    sp_playlist.name = None
-    # Optimally, we should test with both None and [sp_unloaded_track_mock]
-    sp_playlist.tracks = [sp_unloaded_track_mock]
-
-    sp_link = mock.Mock(spec=spotify.Link)
-    sp_link.uri = "spotify:user:alice:playlist:foo"
-    sp_link.type = spotify.LinkType.PLAYLIST
-    sp_link.as_playlist.return_value = sp_playlist
-    sp_playlist.link = sp_link
-
-    return sp_playlist
-
-
-@pytest.fixture
-def sp_playlist_folder_start_mock():
-    sp_playlist_folder_start = mock.Mock(spec=spotify.PlaylistFolder)
-    sp_playlist_folder_start.type = spotify.PlaylistType.START_FOLDER
-    sp_playlist_folder_start.name = "Bar"
-    sp_playlist_folder_start.id = 17
-    return sp_playlist_folder_start
-
-
-@pytest.fixture
-def sp_playlist_folder_end_mock():
-    sp_playlist_folder_end = mock.Mock(spec=spotify.PlaylistFolder)
-    sp_playlist_folder_end.type = spotify.PlaylistType.END_FOLDER
-    sp_playlist_folder_end.id = 17
-    return sp_playlist_folder_end
-
-
-@pytest.fixture
-def sp_playlist_container_mock():
-    sp_playlist_container = mock.Mock(spec=spotify.PlaylistContainer)
-    return sp_playlist_container
-
-
 @pytest.fixture
 def web_search_mock(web_album_mock_base, web_artist_mock, web_track_mock):
     return {
diff --git a/tests/test_browse.py b/tests/test_browse.py
index 5bfcfaf7..88f8f8dd 100644
--- a/tests/test_browse.py
+++ b/tests/test_browse.py
@@ -3,8 +3,6 @@
 import pytest
 from mopidy import models
 
-import spotify
-
 
 def test_has_a_root_directory(provider):
     assert provider.root_directory == models.Ref.directory(
diff --git a/tests/test_lookup.py b/tests/test_lookup.py
index f90296c7..a24e3fbf 100644
--- a/tests/test_lookup.py
+++ b/tests/test_lookup.py
@@ -1,8 +1,6 @@
 import copy
 from unittest import mock
 
-import spotify
-
 
 def test_lookup_of_invalid_uri(provider, caplog):
     results = provider.lookup("invalid")
diff --git a/tests/test_playlists.py b/tests/test_playlists.py
index fc415b49..16905fd1 100644
--- a/tests/test_playlists.py
+++ b/tests/test_playlists.py
@@ -4,7 +4,6 @@
 from mopidy import backend as backend_api
 from mopidy.models import Ref
 
-import spotify
 from mopidy_spotify import playlists
 
 
diff --git a/tests/test_translator.py b/tests/test_translator.py
index 4686d9ab..ac83a0db 100644
--- a/tests/test_translator.py
+++ b/tests/test_translator.py
@@ -3,63 +3,9 @@
 from unittest import mock
 from unittest.mock import patch, sentinel
 
-import spotify
 from mopidy_spotify import translator
 
 
-class TestToArtist:
-    def test_returns_none_if_unloaded(self, sp_artist_mock):
-        sp_artist_mock.is_loaded = False
-
-        artist = translator.to_artist(sp_artist_mock)
-
-        assert artist is None
-
-    def test_successful_translation(self, sp_artist_mock):
-        artist = translator.to_artist(sp_artist_mock)
-
-        assert artist.uri == "spotify:artist:abba"
-        assert artist.name == "ABBA"
-
-    def test_caches_results(self, sp_artist_mock):
-        artist1 = translator.to_artist(sp_artist_mock)
-        artist2 = translator.to_artist(sp_artist_mock)
-
-        assert artist1 is artist2
-
-    def test_does_not_cache_none_results(self, sp_artist_mock):
-        sp_artist_mock.is_loaded = False
-        artist1 = translator.to_artist(sp_artist_mock)
-
-        sp_artist_mock.is_loaded = True
-        artist2 = translator.to_artist(sp_artist_mock)
-
-        assert artist1 is None
-        assert artist2 is not None
-
-
-class TestToArtistRef:
-    def test_returns_none_if_unloaded(self, sp_artist_mock):
-        sp_artist_mock.is_loaded = False
-
-        ref = translator.to_artist_ref(sp_artist_mock)
-
-        assert ref is None
-
-    def test_successful_translation(self, sp_artist_mock):
-        ref = translator.to_artist_ref(sp_artist_mock)
-
-        assert ref.type == "artist"
-        assert ref.uri == "spotify:artist:abba"
-        assert ref.name == "ABBA"
-
-    def test_caches_results(self, sp_artist_mock):
-        ref1 = translator.to_artist_ref(sp_artist_mock)
-        ref2 = translator.to_artist_ref(sp_artist_mock)
-
-        assert ref1 is ref2
-
-
 class TestWebToArtistRef:
     @pytest.mark.parametrize(
         "web_data",
@@ -100,188 +46,6 @@ def test_bad_artists_filtered(self, web_artist_mock, web_track_mock):
         assert refs[0].name == "ABBA"
 
 
-class TestToAlbum:
-    def test_returns_none_if_unloaded(self, sp_album_mock):
-        sp_album_mock.is_loaded = False
-
-        album = translator.to_album(sp_album_mock)
-
-        assert album is None
-
-    def test_successful_translation(self, sp_album_mock):
-        album = translator.to_album(sp_album_mock)
-
-        assert album.uri == "spotify:album:def"
-        assert album.name == "DEF 456"
-        assert list(album.artists) == [
-            models.Artist(uri="spotify:artist:abba", name="ABBA")
-        ]
-        assert album.date == "2001"
-
-    def test_returns_empty_artists_list_if_artist_is_none(self, sp_album_mock):
-        sp_album_mock.artist = None
-
-        album = translator.to_album(sp_album_mock)
-
-        assert list(album.artists) == []
-
-    def test_returns_unknown_date_if_year_is_none(self, sp_album_mock):
-        sp_album_mock.year = None
-
-        album = translator.to_album(sp_album_mock)
-
-        assert album.date is None
-
-    def test_returns_unknown_date_if_year_is_zero(self, sp_album_mock):
-        sp_album_mock.year = 0
-
-        album = translator.to_album(sp_album_mock)
-
-        assert album.date is None
-
-    def test_caches_results(self, sp_album_mock):
-        album1 = translator.to_album(sp_album_mock)
-        album2 = translator.to_album(sp_album_mock)
-
-        assert album1 is album2
-
-
-class TestToAlbumRef:
-    def test_returns_none_if_unloaded(self, sp_album_mock):
-        sp_album_mock.is_loaded = False
-
-        ref = translator.to_album_ref(sp_album_mock)
-
-        assert ref is None
-
-    def test_successful_translation(self, sp_album_mock):
-        ref = translator.to_album_ref(sp_album_mock)
-
-        assert ref.type == "album"
-        assert ref.uri == "spotify:album:def"
-        assert ref.name == "ABBA - DEF 456"
-
-    def test_if_artist_is_none(self, sp_album_mock):
-        sp_album_mock.artist = None
-
-        ref = translator.to_album_ref(sp_album_mock)
-
-        assert ref.name == "DEF 456"
-
-    def test_if_artist_is_not_loaded(self, sp_album_mock):
-        sp_album_mock.artist.is_loaded = False
-
-        ref = translator.to_album_ref(sp_album_mock)
-
-        assert ref.name == "DEF 456"
-
-    def test_caches_results(self, sp_album_mock):
-        ref1 = translator.to_album_ref(sp_album_mock)
-        ref2 = translator.to_album_ref(sp_album_mock)
-
-        assert ref1 is ref2
-
-
-class TestToTrack:
-    def test_returns_none_if_unloaded(self, sp_track_mock):
-        sp_track_mock.is_loaded = False
-
-        track = translator.to_track(sp_track_mock)
-
-        assert track is None
-
-    def test_returns_none_if_error(self, sp_track_mock, caplog):
-        sp_track_mock.error = spotify.ErrorType.OTHER_PERMANENT
-
-        track = translator.to_track(sp_track_mock)
-
-        assert track is None
-        assert (
-            "Error loading 'spotify:track:abc': <ErrorType.OTHER_PERMANENT: 10>"
-            in caplog.text
-        )
-
-    def test_returns_none_if_not_available(self, sp_track_mock):
-        sp_track_mock.availability = spotify.TrackAvailability.UNAVAILABLE
-
-        track = translator.to_track(sp_track_mock)
-
-        assert track is None
-
-    def test_successful_translation(self, sp_track_mock):
-        track = translator.to_track(sp_track_mock, bitrate=320)
-
-        assert track.uri == "spotify:track:abc"
-        assert track.name == "ABC 123"
-        assert list(track.artists) == [
-            models.Artist(uri="spotify:artist:abba", name="ABBA")
-        ]
-        assert track.album == models.Album(
-            uri="spotify:album:def",
-            name="DEF 456",
-            artists=[models.Artist(uri="spotify:artist:abba", name="ABBA")],
-            date="2001",
-        )
-        assert track.track_no == 7
-        assert track.disc_no == 1
-        assert track.date == "2001"
-        assert track.length == 174300
-        assert track.bitrate == 320
-
-    def test_filters_out_none_artists(self, sp_artist_mock, sp_track_mock):
-        sp_artist_mock.is_loaded = False
-
-        track = translator.to_track(sp_track_mock)
-
-        assert list(track.artists) == []
-
-    def test_caches_results(self, sp_track_mock):
-        track1 = translator.to_track(sp_track_mock)
-        track2 = translator.to_track(sp_track_mock)
-
-        assert track1 is track2
-
-
-class TestToTrackRef:
-    def test_returns_none_if_unloaded(self, sp_track_mock):
-        sp_track_mock.is_loaded = False
-
-        ref = translator.to_track_ref(sp_track_mock)
-
-        assert ref is None
-
-    def test_returns_none_if_error(self, sp_track_mock, caplog):
-        sp_track_mock.error = spotify.ErrorType.OTHER_PERMANENT
-
-        ref = translator.to_track_ref(sp_track_mock)
-
-        assert ref is None
-        assert (
-            "Error loading 'spotify:track:abc': <ErrorType.OTHER_PERMANENT: 10>"
-            in caplog.text
-        )
-
-    def test_returns_none_if_not_available(self, sp_track_mock):
-        sp_track_mock.availability = spotify.TrackAvailability.UNAVAILABLE
-
-        ref = translator.to_track_ref(sp_track_mock)
-
-        assert ref is None
-
-    def test_successful_translation(self, sp_track_mock):
-        ref = translator.to_track_ref(sp_track_mock)
-
-        assert ref.type == models.Ref.TRACK
-        assert ref.uri == "spotify:track:abc"
-        assert ref.name == "ABC 123"
-
-    def test_caches_results(self, sp_track_mock):
-        ref1 = translator.to_track_ref(sp_track_mock)
-        ref2 = translator.to_track_ref(sp_track_mock)
-
-        assert ref1 is ref2
-
-
 class TestValidWebData(object):
     def test_returns_false_if_none(self):
         assert translator.valid_web_data(None, "track") is False

